﻿
#include "pch.h"
#include "framework.h"
#include "myDLL.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define dxp extern "C" __declspec(dllexport)


//******************************************************************
dxp int TestArrayOfInts(int* pArray, int size)
{
	int result = 0;

	for (int i = 0; i < size; i++)
	{
		result += pArray[i];
		pArray[i] += 100;
	}
	return result;
}

//******************************************************************
dxp int TestRefArrayOfInts(int** ppArray, int* pSize)
{
	int result = 0;

	// CoTaskMemAlloc must be used instead of the new operator
	// because code on the managed side will call Marshal.FreeCoTaskMem
	// to free this memory.

	int* newArray = (int*)CoTaskMemAlloc(sizeof(int) * 5);

	for (int i = 0; i < *pSize; i++)
	{
		result += (*ppArray)[i];
	}

	for (int j = 0; j < 5; j++)
	{
		newArray[j] = (*ppArray)[j] + 100;
	}

	CoTaskMemFree(*ppArray);
	*ppArray = newArray;
	*pSize = 5;

	return result;
}


// 내가 추가한 함수의 끝 나머지 부분은 자동생성되었음
// CmyDLLApp

BEGIN_MESSAGE_MAP(CmyDLLApp, CWinApp)
END_MESSAGE_MAP()


// CmyDLLApp 생성

CmyDLLApp::CmyDLLApp()
{
	// TODO: 여기에 생성 코드를 추가합니다.
	// InitInstance에 모든 중요한 초기화 작업을 배치합니다.
}


// 유일한 CmyDLLApp 개체입니다.

CmyDLLApp theApp;


// CmyDLLApp 초기화

BOOL CmyDLLApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}

